/*****************************************************************************
   MODULE: rbput.c
  PURPOSE: recio character delimited integral number output functions
COPYRIGHT: (C) 1994 William Pierpoint
 COMPILER: Borland C Version 3.1
       OS: MSDOS Version 6.2
  VERSION: 2.02
  RELEASE: May 5, 1994
*****************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "recio.h"

extern int _rstatus(REC *rp, int mode);
extern int _rputc(REC *rp, int ch);

#define rfp(rp)          ((rp)->r_fp)
#define rcol(rp)         ((rp)->r_colno)
#define rfldch(rp)       ((rp)->r_fldch)

#define ulong            unsigned long
#define UNSIGNED         0
#define SIGNED           1

/****************************************************************************/
static int                   /* return error status (0=no error; !0=error)  */
    _rbputl(                 /* output integral number to record stream     */
        REC *rp,             /* pointer to record stream                    */
        int  base,           /* base (radix) (2 to 36)                      */
        int  sign,           /* signed number (1=signed; 0=unsigned)        */
        long num)            /* number to put to stream                     */
/****************************************************************************/
{
    int err=EOF;             /* return error (0=no error; !0=error) */
    if (!_rstatus(rp, R_WRITE)) { 
        if (base >= 2 && base <= 36) { 
            rfldno(rp)++; 
            /* if not first field, put field separator */
            if (rfldno(rp) > 1) { 
                err = _rputc(rp, rfldch(rp)); 
                if (err) goto done; 
            }
            if (sign) {
                ltoa(num, _r_nsbuf, base);
            } else {
                ultoa((ulong)num, _r_nsbuf, base);
            }
            err = fputs(_r_nsbuf, rfp(rp)); 
            if (err==EOF) { 
                rseterr(rp, R_ENOPUT); 
                goto done; 
            } else { 
                rcol(rp) += strlen(_r_nsbuf); 
                err = 0; 
                goto done; 
            } 
        } 
        rseterr(rp, R_EINVAL); 
    } 
done: 
    return err; 
}

/****************************************************************************/
/* character delimited integral number output functions                     */
/****************************************************************************/
int rbputi(REC *rp, int base, int num)
{
    return _rbputl(rp, base, SIGNED, (long) num);
}

int rbputui(REC *rp, int base, unsigned int num)
{
    return _rbputl(rp, base, UNSIGNED, (long) num);
}

int rbputl(REC *rp, int base, long num)
{
    return _rbputl(rp, base, SIGNED, num);
}

int rbputul(REC *rp, int base, unsigned long num)
{
    return _rbputl(rp, base, UNSIGNED, (long) num);
}
